//package com.Kettle.kettle;
//
//import lombok.extern.slf4j.Slf4j;
//import org.pentaho.di.core.KettleEnvironment;
//import org.pentaho.di.core.logging.KettleLogStore;
//import org.pentaho.di.core.util.EnvUtil;
//import org.pentaho.di.trans.Trans;
//import org.pentaho.di.trans.TransMeta;
//
//import java.util.HashMap;
//import java.util.Map;
//
//@Slf4j
//public class doTransfer {
//    public static Map<String, String> runTransfer(String[] paramsKeyList, String[] paramsValueList, String sysdate, String ktrPath) {
//        Trans trans;
//        Map<String, String> logMap = new HashMap<>();
//        String ktrBatchId = null;
//        String ktrName = null;
//        String runState = "1";
//        String errorInfo = "";
//        try {
//            KettleEnvironment.init();// 初始化
//            EnvUtil.environmentInit();
//            TransMeta transMeta = new TransMeta(ktrPath);
//            // 转换
//            trans = new Trans(transMeta);
//            trans.setParameterValue("SYS_DATE_TIME", sysdate);
//            //设置变量
//            if (paramsKeyList != null) {
//                for (int i = 0; i < paramsKeyList.length; i++) {
//                    trans.setParameterValue(paramsKeyList[i], paramsValueList[i]);
//                }
//            }
//            // 执行转换
//            trans.execute(null);
//            // 等待转换执行结束
//            trans.waitUntilFinished();
//            //获取执行记录
//            if (trans.isFinished()) {
//                ktrBatchId = String.valueOf(trans.getBatchId());
//                ktrName = trans.getName();
//            } else {
//                runState = "2";
//            }
//            // 抛出异常
//            if (trans.getErrors() > 0) {
//                System.out.println("There are errors during transformation exception!(传输过程中发生异常)");
//                String[] errMsgList = KettleLogStore.getAppender().getBuffer(trans.getLogChannelId(), false).toString().split("\n\r\n");
//                String errMsg = errMsgList[0];
//                log.error("Kettle运行报错：" + errMsg);
//                if (errMsg.contains("duplicate key value violates")) { //违反唯一约束
//                    System.out.println("执行删除重复数据操作");
//                    logMap.put("runState", "3");
//                    logMap.put("errorInfo", errMsg);
//                    return logMap;
//                } else {
//                    errorInfo = "未知报错";
//                    runState = "2";
//                }
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//            runState = "2";
//            errorInfo = e.getMessage();
//            log.error(e.getMessage());
//        }
//
////        记录Job运行日志
//        logMap.put("batchId", String.valueOf(ktrBatchId));
//        logMap.put("jobName", ktrName);
//        logMap.put("runState", runState);
//        logMap.put("errorInfo", errorInfo);
//        return logMap;
//    }
//
//}
