package com.Kettle.schedule.DangerOperateBoat;

import com.xxl.job.core.biz.model.ReturnT;
import com.xxl.job.core.handler.annotation.XxlJob;
import com.xxl.job.core.log.XxlJobLogger;
import org.pentaho.di.core.exception.KettleException;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.PropertySource;
import org.springframework.stereotype.Component;

import static com.Kettle.utils.runtransfer.runTransfer;
//具有危险品运营资质船舶信息同步
@Component
@PropertySource(value = "classpath:/KettleFiles.properties", encoding = "GBK")
public class DangerOperateBoatJob {
    @Value("${Kettle.DangerBoatInfo}")
    private String dangerOperateBoat;
    @XxlJob("dangerOperateBoat")
    public ReturnT<String> dangerOperateBatJob(String param){
        try {
            runTransfer(dangerOperateBoat);
        } catch (KettleException e) {
            e.printStackTrace();
            XxlJobLogger.log(e.getMessage() + dangerOperateBoat);
        }
        return ReturnT.SUCCESS;
    }
}
