package com.Kettle.schedule.DeclareZd;

import com.xxl.job.core.biz.model.ReturnT;
import com.xxl.job.core.handler.annotation.XxlJob;
import com.xxl.job.core.log.XxlJobLogger;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.PropertySource;
import org.springframework.stereotype.Component;

import static com.Kettle.utils.runtransfer.runTransfer;

@Component
@PropertySource(value = "classpath:/KettleFiles.properties", encoding = "GBK")
public class DeclareZdJob {
    @Value("${Kettle.Oth05.HANGYEUPDATE}")
    private String hangYeUpdate;
    @Value("${Kettle.Oth05.HANGYEUPDATEPORTCOMPANYINFO}")
    private String hangYeCompanyInfo;
    @XxlJob("sb_Job_zd")
    public ReturnT<String> declareZdKettle(String param){
        int i = 0;
        try {
            runTransfer(hangYeUpdate);
        }catch (Exception e){
            e.printStackTrace();
            XxlJobLogger.log(hangYeUpdate + "异常" + e.getMessage());
            i++;
        }
        try {
            runTransfer(hangYeCompanyInfo);
        }catch (Exception e){
            e.printStackTrace();
            XxlJobLogger.log(hangYeCompanyInfo + "异常" + e.getMessage());
            i++;
        }
        if (i==0){
            return ReturnT.SUCCESS;
        }else {
            return ReturnT.FAIL;
        }
    }
}
