package com.Kettle.schedule.EverySeason;

import com.xxl.job.core.biz.model.ReturnT;
import com.xxl.job.core.handler.annotation.XxlJob;
import com.xxl.job.core.log.XxlJobLogger;
import org.pentaho.di.core.exception.KettleException;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.PropertySource;
import org.springframework.stereotype.Component;

import static com.Kettle.utils.runtransfer.runTransfer;
//每季度
@Component
@PropertySource(value = "classpath:/KettleFiles.properties", encoding = "GBK")
public class HangDaoSignJob {
    @Value("${Kettle.EverySeasonHangDaoSign}")
    private String kettlePath;
    @XxlJob("EverySeasonHangDaoSign")
    public ReturnT<String> EverySeasonHangDaoSign(String param){
        try {
            runTransfer(kettlePath);
        } catch (KettleException e) {
            e.printStackTrace();
            XxlJobLogger.log(e.getMessage() + kettlePath);
            return ReturnT.FAIL;
        }
        return ReturnT.SUCCESS;
    }
}
