package com.Kettle.schedule.GangHang221;

import com.xxl.job.core.biz.model.ReturnT;
import com.xxl.job.core.handler.annotation.XxlJob;
import com.xxl.job.core.log.XxlJobLogger;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.PropertySource;
import org.springframework.stereotype.Component;

import static com.Kettle.utils.runtransfer.runTransfer;

@Component
@PropertySource(value = "classpath:/KettleFiles.properties", encoding = "GBK")
public class GangHangJob {
    @Value("${Kettle.Oth05.SomeCertInfo}")
    private String someCertInfo;
    @Value("${Kettle.Oht05.DeclareCancelTest}")
    private String declareCancelTest;
    @XxlJob("gangHang221")
    public ReturnT<String> gangHangKettle(String param){
        int i = 0;
        try {
            runTransfer(someCertInfo);
        }catch (Exception e){
            e.printStackTrace();
            XxlJobLogger.log(someCertInfo + "异常" + e.getMessage());
            i++;
        }
        try {
            runTransfer(declareCancelTest);
        }catch (Exception e){
            e.printStackTrace();
            XxlJobLogger.log(declareCancelTest + "异常" + e.getMessage());
            i++;
        }
        if (i==0){
            return ReturnT.SUCCESS;
        }else {
            return ReturnT.FAIL;
        }
    }
}
