package com.Kettle.schedule.HaiBoDanger;

import com.xxl.job.core.biz.model.ReturnT;
import com.xxl.job.core.handler.annotation.XxlJob;
import com.xxl.job.core.log.XxlJobLogger;
import org.pentaho.di.core.exception.KettleException;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.PropertySource;
import org.springframework.stereotype.Component;

import static com.Kettle.utils.runtransfer.runTransfer;

@Component
@PropertySource(value = "classpath:/KettleFiles.properties", encoding = "GBK")
public class HaiBoDangerJob {
    @Value("${Kettle.HaiBoDanger}")
    private String kettlePath;
    //海渤危险品同步作业
    @XxlJob("HaiBoDanger")
    public ReturnT<String> HaiBoDangerKettle(String param){
        try {
            runTransfer(kettlePath);
        } catch (KettleException e) {
            e.printStackTrace();
            XxlJobLogger.log(e.getMessage() + kettlePath);
            return ReturnT.FAIL;
        }
        return ReturnT.SUCCESS;
    }
}
