package com.Kettle.schedule.HsxBasicInfo;

import com.xxl.job.core.biz.model.ReturnT;
import com.xxl.job.core.handler.annotation.XxlJob;
import com.xxl.job.core.log.XxlJobLogger;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.PropertySource;
import org.springframework.stereotype.Component;

import static com.Kettle.utils.runtransfer.runTransfer;

@Component
@PropertySource(value = "classpath:/KettleFiles.properties", encoding = "GBK")
public class HsxBasicInfoJob {
    @Value("${Kettle.Oth05.hsx_basic_info}")
    public String hsxBasicInfo;
    @XxlJob("hsxBasicInfo")
    public ReturnT<String> hsxBasicInfoKettle(String param){
        try{
            runTransfer(hsxBasicInfo);
        }catch (Exception e){
            e.getMessage();
            XxlJobLogger.log(hsxBasicInfo + "异常" + e.getMessage());
            return ReturnT.FAIL;
        }
        return ReturnT.SUCCESS;
    }
}
