package com.Kettle.schedule.LineHYSJZX;

import com.xxl.job.core.biz.model.ReturnT;
import com.xxl.job.core.handler.annotation.XxlJob;
import com.xxl.job.core.log.XxlJobLogger;
import org.pentaho.di.core.exception.KettleException;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.PropertySource;
import org.springframework.stereotype.Component;

import static com.Kettle.utils.runtransfer.runTransfer;

@Component
@PropertySource(value = "classpath:/KettleFiles.properties", encoding = "GBK")
public class LineToHYSJZXJob {
    @Value("${Kettle.LINE.HYSJZX}")
    private String lineToHYSJZX;

    @XxlJob("LineToHYSJZX")
    private ReturnT<String> LineToHYSJZXKettle(String param){
        try{
            runTransfer(lineToHYSJZX);
        } catch (KettleException e) {
            e.printStackTrace();
            XxlJobLogger.log(e.getMessage() + lineToHYSJZX);
            return ReturnT.FAIL;
        }
        return ReturnT.SUCCESS;
    }
}
