package com.Kettle.schedule.Weather;

import com.xxl.job.core.biz.model.ReturnT;
import com.xxl.job.core.handler.annotation.XxlJob;
import com.xxl.job.core.log.XxlJobLogger;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.PropertySource;
import org.springframework.stereotype.Component;

import static com.Kettle.utils.runtransfer.runTransfer;
//2023年8月21日
@Component
@PropertySource(value = "classpath:/KettleFiles.properties", encoding = "GBK")
public class WeatherJob {
    @Value("${Kettle.Weather.HYSJZXToPro}")
    private String weatherHysjzxToPro;
//    @Value("${Kettle.Weather.CHSX}")
//    private String weatherChsx;

    @XxlJob("Weather")
    public ReturnT<String> weatherKettle(String param){
        try {
            runTransfer(weatherHysjzxToPro);
        }catch (Exception e){
            e.printStackTrace();
            XxlJobLogger.log(e.getMessage() + weatherHysjzxToPro);
            return ReturnT.FAIL;
        }
        return ReturnT.SUCCESS;
    }
}
