//package com.example.test;
//
//
//import java.io.IOException;
//import java.sql.SQLException;
//import java.util.HashMap;
//import java.util.List;
//import java.util.Map;
//
//import com.shcd.entity.ResultSelectMsg;
//import com.shcd.mapperImpl.PTJK.dataExchange.DataExchangeImpl;
//import com.shcd.service.KettleTools;
//import com.shcd.tools.DataFormatTools;
//import com.shcd.tools.PageTools;
//import org.apache.log4j.Logger;
//import org.json.JSONObject;
//import org.pentaho.di.core.KettleEnvironment;
//import org.pentaho.di.core.database.DatabaseMeta;
//import org.pentaho.di.core.exception.KettleException;
//import org.pentaho.di.core.logging.KettleLogStore;
//import org.pentaho.di.core.util.EnvUtil;
//import org.pentaho.di.job.Job;
//import org.pentaho.di.job.JobMeta;
//import org.pentaho.di.trans.Trans;
//import org.pentaho.di.trans.TransMeta;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.beans.factory.annotation.Value;
//import org.springframework.stereotype.Service;
//
// * @ClassName KettleService
// * @Description TODO Kettle功能方法   主要逻辑: 通过八位码查询任务列表，根据通道判断任务job路径和命名参数调用执行，执行完毕后记录日志
// * @Author Echo
// * @Date 2021/8/9 11:21
// * @Version 1.0
//
//
//
//
//@Service
//public class ExchangeKettleService {
//    //    Job变量名List
//    private static String[] PARAMS_LIST = {"SYS_DATE_TIME", ""};
//
//    @Value("${kettle.job.path}")
//    private String JOB_PATH;
//
//    @Autowired
//    private DataExchangeImpl dataExchange;
//
//    @Autowired
//    private KettleTransService kettleTransService;
//
//
//    @Autowired
//    private static Logger log = Logger.getLogger(ExchangeKettleService.class);
//
//*
//     * @return java.util.Map<java.lang.String, java.lang.String>
//     * KettleMode ： //0：Gxjh；1：Zwxx；2：xyxx；3：Dm；4：SXY；5：DA
//     * @Author zhh
//     * @Description //TODO 查询配置，执行Kettle文件   * @Date 10:30 2021/8/20
//     * @Param [m]
//     *
//
//
//    public JSONObject exchangeTaskRun(Map<String, String> m) throws KettleException {
//        JSONObject returnJson = new JSONObject();
//        Map<String, String> params = new HashMap<>();
//        Map<String, String> logMap = new HashMap<>();
//        Map<String, String> transferLogMap = new HashMap<>(); //日志转换运行Map信息
//        String cid = m.get("CID");
//        //根据八位码查询单位编号
//        String unitCode = dataExchange.queryCatalogUnitCode(cid);
//        List<Map> exchangeTaskList = dataExchange.queryExchangeTaskList(m);
//        //如果有需要执行的任务 则修改任务状态
//        if (exchangeTaskList.size() > 0) {
//            params.put("states", "2");
//            params.put("cid", cid);
//            int taskStates = dataExchange.updateExchangeTaskStates(params);
//        }
//        for (Map<String, String> task : exchangeTaskList) {
//            String kettleMode = task.get("SEGMENT_ID");
//            String fileName = "";
//            String logFileName = "";
//            String stepName = "";
//            //Kettle模式 判别
//            if (kettleMode.equals("0")) {
//                stepName = "A";
//            } else {
//                stepName = kettleMode;
//            }
//            //查询是否需要生成Ktr文件
//            String whetherCreate = task.get("WHETHER_CREATE");
//            Map<String, String> createTranMap = new HashMap<>();
//            createTranMap.put("UNIT_CODE", unitCode);
//            createTranMap.put("STEP_CODE", stepName);
//            createTranMap.put("CID", cid);
//            if (whetherCreate.equals("1")) {
//                kettleTransService.createTrans(createTranMap);
////                    log.error("生成Kettle脚本失败！错误信息："+e);
//                //修改为‘0’
//                int updateInt = dataExchange.updateWhetherCreate(cid, kettleMode);
//            }
//
//            String tableName = task.get("TABNAME");
//            fileName = stepName + "_" + tableName + ".ktr";
//            logFileName = stepName + "_" + tableName + "(LOG).ktr";
//            String path = JOB_PATH + "/" + unitCode + "/" + tableName + "/";
//            String sysdate = dataExchange.getSysdate();
//            String lastMonth = dataExchange.getLastMonth();
//            String thisMonth = dataExchange.getThisMonth();
//            //处理变量List
//            String paramsKeyStr = task.get("PARAMETERDEFINATIONNAME");
//            String paramsValueStr = task.get("PARAMETERDEFINATIONVALUE");
//            String[] paramsKeyList = null;
//            String[] paramsValueList = null;
//            //变量名单独处理
//            switch (cid) {
//                //公积金的两张表是每个月自动生成的
//                case "03410402":
////                    transferParams.put("TABLE_NAME","GXJH_GJJ_DWJC_"+lastMonth);
////                    transferParams.put("FQ_NAME","DWJC"+thisMonth);
//                    paramsKeyStr = "TABLE_NAME" + "，" + "FQ_NAME";
//                    paramsValueStr = "GXJH_GJJ_DWJC_" + lastMonth + "，" + "DWJC" + thisMonth;
//                    break;
//                case "03410403":
////                    transferParams.put("TABLE_NAME","GXJH_GJJ_GRJC_"+lastMonth); //前置机表明
////                    transferParams.put("FQ_NAME","GRJC"+thisMonth);//共享交换分区表名称
//                    paramsKeyStr = "TABLE_NAME" + "，" + "FQ_NAME";
//                    paramsValueStr = "GXJH_GJJ_GRJC_" + lastMonth + "，" + "GRJC" + thisMonth;
//                    break;
//            }
//            if (paramsKeyStr != null && paramsValueStr != null) {
//                paramsKeyList = paramsKeyStr.split("，");
//                paramsValueList = paramsValueStr.split("，");
//            }
//            //修改任务主表状态
//            try {
//                logMap = runTransfer(paramsKeyList, paramsValueList, sysdate, path + fileName);
//                String runState = logMap.get("runState");
//                String errorInfo = logMap.get("errorInfo");
//                switch (runState) {
//                    case "1": //执行成功
//                        transferLogMap = runTransfer(paramsKeyList, paramsValueList, sysdate, path + logFileName);
//                        break;
//                    case "2": //未知报错
//                        logMap.put("errorInfo", errorInfo);
//                        break;
//                    case "3": //唯一约束
//                        long deleteCount = kettleTransService.deleteDuplicateData(stepName, cid);
//                        logMap.put("errorInfo", "违反唯一约束,共自动删除" + deleteCount + "条数据");
//                        break;
//                }
//            } catch (Exception e) {
//                logMap.put("errorInfo", e.getMessage());
//                log.error("Kettle运行失败！错误信息：" + e);
//            }
//            m.put("stepName", stepName);
////            查询Kettle_run表最新一条数据的实际完成条数
//            int exchangeCount = dataExchange.getExchangeCount(m);
//            returnJson.put(stepName, String.valueOf(exchangeCount));
//            logMap.put("exchangeCount", String.valueOf(exchangeCount));
//            logMap.put("cid", cid);
//            logMap.put("kettleMode", kettleMode);
//            int InsertLog = dataExchange.insertKettleJobRunningLog(logMap);
//            params.put("states", "1");
//            int taskStates = dataExchange.updateExchangeTaskStates(params);
//        }
//        return returnJson;
//    }
//
//    //运行Job
//    public Map<String, String> runJob(Map<String, String> params, String jobPath) {
//        Map<String, String> m = new HashMap<>();
//        Map<String, String> logMap = new HashMap<>();
//        String runState = "1";
//        long jobBatchId = new Long(1);
//        String jobName = "";
//        String errorInfo = "";
//        try {
//            KettleEnvironment.init();
//            // jobname 是Job脚本的路径及名称
//            JobMeta jobMeta = new JobMeta(jobPath, null);
//            Job job = new Job(null, jobMeta);
//            List<DatabaseMeta> dmList = jobMeta.getDatabases();
//            //2、向Job 脚本传递参数，脚本中获取参数值：${参数名}
//            if (params.size() < 0) {
//                for (int i = 0; i < params.size(); i++) {
//                    job.setVariable(PARAMS_LIST[i], params.get(PARAMS_LIST[i]));
//                }
//            }
//            jobName = job.getJobname();
//            job.start();
//            job.waitUntilFinished();
//            if (job.getErrors() > 0) {
//                runState = "2";
//            }
//            jobBatchId = job.getBatchId();
//
//        } catch (Exception e) {
//            e.printStackTrace();
//            runState = "2";
//            errorInfo = e.getMessage();
//        }
////        记录Job运行日志
//        logMap.put("batchId", String.valueOf(jobBatchId));
//        logMap.put("jobName", jobName);
//        logMap.put("runState", runState);
//        logMap.put("errorInfo", errorInfo);
//        return logMap;
//    }
//
//    //执行转换
//    public static Map<String, String> runTransfer(String[] paramsKeyList, String[] paramsValueList, String sysdate, String ktrPath) {
//        Trans trans;
//        Map<String, String> logMap = new HashMap<>();
//        String ktrBatchId = null;
//        String ktrName = null;
//        String runState = "1";
//        String errorInfo = "";
//        try {
//            KettleEnvironment.init();// 初始化
//            EnvUtil.environmentInit();
//            TransMeta transMeta = new TransMeta(ktrPath);
//            // 转换
//            trans = new Trans(transMeta);
//            trans.setParameterValue("SYS_DATE_TIME", sysdate);
//            //设置变量
//            if (paramsKeyList != null) {
//                for (int i = 0; i < paramsKeyList.length; i++) {
//                    trans.setParameterValue(paramsKeyList[i], paramsValueList[i]);
//                }
//            }
//            // 执行转换
//            trans.execute(null);
//            // 等待转换执行结束
//            trans.waitUntilFinished();
//            //获取执行记录
//            if (trans.isFinished()) {
//                ktrBatchId = String.valueOf(trans.getBatchId());
//                ktrName = trans.getName();
//            } else {
//                runState = "2";
//            }
//            // 抛出异常
//            if (trans.getErrors() > 0) {
//                System.out.println("There are errors during transformation exception!(传输过程中发生异常)");
//                String[] errMsgList = KettleLogStore.getAppender().getBuffer(trans.getLogChannelId(), false).toString().split("\n\r\n");
//                String errMsg = errMsgList[0];
//                log.error("Kettle运行报错：" + errMsg);
//                if (errMsg.contains("duplicate key value violates")) { //违反唯一约束
//                    System.out.println("执行删除重复数据操作");
//                    logMap.put("runState", "3");
//                    logMap.put("errorInfo", errMsg);
//                    return logMap;
//                } else {
//                    errorInfo = "未知报错";
//                    runState = "2";
//                }
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//            runState = "2";
//            errorInfo = e.getMessage();
//            log.error(e);
//        }
//
////        记录Job运行日志
//        logMap.put("batchId", String.valueOf(ktrBatchId));
//        logMap.put("jobName", ktrName);
//        logMap.put("runState", runState);
//        logMap.put("errorInfo", errorInfo);
//        return logMap;
//    }
//
//    //查询首页
//    public String queryExchangeLogHomePage(net.sf.json.JSONObject o) {
//        Map map = PageTools.getPageParaMap(o);
//        ResultSelectMsg msg = new ResultSelectMsg();
//        //数据总条数
//        msg.setTotalRowCount(dataExchange.getExchangeLogHomePageCount(map));
//        msg.setRows(dataExchange.queryExchangeLogHomePage(map));
//        String[] keys = new String[]{"IN_PARA", "OUT_PARA"};
//        DataFormatTools.clobToStringList(msg.getRows(), keys);
//        JSONObject pagelist = new JSONObject(msg.getMsg());
//        return pagelist.toString();
//    }
//
//    //    详情页查询
//    public String queryExchangeLogDetailPage(net.sf.json.JSONObject o) {
//        Map map = PageTools.getPageParaMap(o);
//        ResultSelectMsg msg = new ResultSelectMsg();
//        //数据总条数
//        msg.setTotalRowCount(dataExchange.getExchangeLogDetailPageCount(map));
//        msg.setRows(dataExchange.queryExchangeLogDetailPage(map));
//        String[] keys = new String[]{"IN_PARA", "OUT_PARA"};
//        DataFormatTools.clobToStringList(msg.getRows(), keys);
//        JSONObject pagelist = new JSONObject(msg.getMsg());
//        return pagelist.toString();
//    }
//
//    //查询Kettle运行情况
//    public String queryExchangeLogDetailPageFile(net.sf.json.JSONObject o) throws IOException, SQLException {
//        Map map = PageTools.getPageParaMap(o);
//        ResultSelectMsg msg = new ResultSelectMsg();
//        //数据总条数
//        msg.setTotalRowCount(1);
//        msg.setRows(dataExchange.queryExchangeLogDetailPageFile(map));
//        String[] keys = new String[]{"IN_PARA", "OUT_PARA"};
//        DataFormatTools.clobToStringList(msg.getRows(), keys);
//        JSONObject pagelist = new JSONObject(msg.getMsg());
//        return pagelist.toString();
//    }
//}
