package com.Kettle.schedule.AisAndRfid;

import com.xxl.job.core.biz.model.ReturnT;
import com.xxl.job.core.handler.annotation.XxlJob;
import com.xxl.job.core.log.XxlJobLogger;
import org.pentaho.di.core.exception.KettleException;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.PropertySource;
import org.springframework.stereotype.Component;

import static com.Kettle.utils.runtransfer.runTransfer;

//aisandrfid5秒
@Component
@PropertySource(value = "classpath:/KettleFiles.properties", encoding = "GBK")
public class AisAndRfidJob {
    @Value("${Kettle.AISANDRFIDAIS}")
    private String aisAndRfidAis;
    @XxlJob("AisAndRfid")
    public ReturnT<String> aisAndRfidKettle(String param){
        try {
            //System.out.println("-------------"  + param);
            runTransfer(aisAndRfidAis);
        } catch (KettleException e) {
            e.printStackTrace();
            XxlJobLogger.log(e.getMessage() + aisAndRfidAis);
        }
        return ReturnT.SUCCESS;
    }
}
