package com.Kettle.schedule.HsxArrive;

import com.xxl.job.core.biz.model.ReturnT;
import com.xxl.job.core.handler.annotation.XxlJob;
import com.xxl.job.core.log.XxlJobLogger;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.PropertySource;
import org.springframework.stereotype.Component;

import static com.Kettle.utils.runtransfer.runTransfer;

@Component
@PropertySource(value = "classpath:/KettleFiles.properties", encoding = "GBK")
public class HsxArriveJob {
    @Value("${Kettle.Oth05.BoatArriveData}")
    private String boatArriveHsx;

    @XxlJob("boatArriveDatAJob")
    public ReturnT<String> hsxArriveKettle(String param) {
        try {
            runTransfer(boatArriveHsx);
        } catch (Exception e) {
            e.getMessage();
            XxlJobLogger.log(boatArriveHsx + "异常" + e.getMessage());
            return ReturnT.FAIL;
        }
        return ReturnT.SUCCESS;
    }
}
