package com.Kettle.schedule;


import com.xxl.job.core.biz.model.ReturnT;
import com.xxl.job.core.handler.annotation.XxlJob;
import com.xxl.job.core.log.XxlJobLogger;
import org.springframework.stereotype.Component;
import static com.Kettle.utils.runtransfer.runTransfer;

@Component
public class TestKettle {
//
    @XxlJob("KettleJob")
    public ReturnT<String> testKettle(String param){
        try{
            //String kettleFilePath = ResourceUtils.getFile("Kettle/港务大厦AIS数据实时同步到测试库.ktr").getAbsolutePath();
            String kettleFilePath = "E:/MyKettle/港务大厦AIS数据实时同步到测试库.ktr";
            runTransfer(kettleFilePath);
        }catch (Exception e){
            e.printStackTrace();
            XxlJobLogger.log(e.getMessage());
            return ReturnT.FAIL;
        }
        return ReturnT.SUCCESS;
    }
}
